--Memory module instantiated in the example design top level in VHDL
library ieee;
use ieee.std_logic_1164.all;
library Axcelerator;

entity memory is 
    port( Data : in std_logic_vector(7 downto 0); Q : out 
        std_logic_vector(7 downto 0); WAddress : in 
        std_logic_vector(6 downto 0); RAddress : in 
        std_logic_vector(6 downto 0);WE, RE, WClock, RClock : in 
        std_logic) ;
end memory;


architecture DEF_ARCH of  memory is

    component INV
        port(A : in std_logic := 'U'; Y : out std_logic) ;
    end component;

    component RAM64K36P
        port(WCLK, RCLK, DEPTH0, DEPTH1, DEPTH2, DEPTH3, WEN, WW0, 
        WW1, WW2, WRAD0, WRAD1, WRAD2, WRAD3, WRAD4, WRAD5, WRAD6, 
        WRAD7, WRAD8, WRAD9, WRAD10, WRAD11, WRAD12, WRAD13, 
        WRAD14, WRAD15, WD0, WD1, WD2, WD3, WD4, WD5, WD6, WD7, 
        WD8, WD9, WD10, WD11, WD12, WD13, WD14, WD15, WD16, WD17, 
        WD18, WD19, WD20, WD21, WD22, WD23, WD24, WD25, WD26, 
        WD27, WD28, WD29, WD30, WD31, WD32, WD33, WD34, WD35, REN, 
        RW0, RW1, RW2, RDAD0, RDAD1, RDAD2, RDAD3, RDAD4, RDAD5, 
        RDAD6, RDAD7, RDAD8, RDAD9, RDAD10, RDAD11, RDAD12, 
        RDAD13, RDAD14, RDAD15 : in std_logic := 'U'; RD0, RD1, 
        RD2, RD3, RD4, RD5, RD6, RD7, RD8, RD9, RD10, RD11, RD12, 
        RD13, RD14, RD15, RD16, RD17, RD18, RD19, RD20, RD21, 
        RD22, RD23, RD24, RD25, RD26, RD27, RD28, RD29, RD30, 
        RD31, RD32, RD33, RD34, RD35 : out std_logic) ;
    end component;

    component VCC
        port( Y : out std_logic);
    end component;

    component GND
        port( Y : out std_logic);
    end component;

    signal INV_1_Y, INV_0_Y, VCC_1_net, GND_1_net : std_logic ;
    begin   

    VCC_2_net : VCC port map(Y => VCC_1_net);
    GND_2_net : GND port map(Y => GND_1_net);
    INV_0 : INV
   port map(A => RE, Y => INV_0_Y);
    INV_1 : INV
   port map(A => WE, Y => INV_1_Y);
    RAM64K36P_Q_0_inst : RAM64K36P
   port map(WCLK => WClock, RCLK => RClock, DEPTH0 => GND_1_net, 
        DEPTH1 => GND_1_net, DEPTH2 => GND_1_net, DEPTH3 => 
        GND_1_net, WEN => INV_1_Y, WW0 => VCC_1_net, WW1 => 
        VCC_1_net, WW2 => GND_1_net, WRAD0 => WAddress(0), 
        WRAD1 => WAddress(1), WRAD2 => WAddress(2), WRAD3 => 
        WAddress(3), WRAD4 => WAddress(4), WRAD5 => WAddress(5), 
        WRAD6 => WAddress(6), WRAD7 => GND_1_net, WRAD8 => 
        GND_1_net, WRAD9 => GND_1_net, WRAD10 => GND_1_net, 
        WRAD11 => GND_1_net, WRAD12 => GND_1_net, WRAD13 => 
        GND_1_net, WRAD14 => GND_1_net, WRAD15 => GND_1_net, 
        WD0 => Data(0), WD1 => Data(1), WD2 => Data(2), WD3 => 
        Data(3), WD4 => Data(4), WD5 => Data(5), WD6 => Data(6), 
        WD7 => Data(7), WD8 => GND_1_net, WD9 => GND_1_net, 
        WD10 => GND_1_net, WD11 => GND_1_net, WD12 => GND_1_net, 
        WD13 => GND_1_net, WD14 => GND_1_net, WD15 => GND_1_net, 
        WD16 => GND_1_net, WD17 => GND_1_net, WD18 => GND_1_net, 
        WD19 => GND_1_net, WD20 => GND_1_net, WD21 => GND_1_net, 
        WD22 => GND_1_net, WD23 => GND_1_net, WD24 => GND_1_net, 
        WD25 => GND_1_net, WD26 => GND_1_net, WD27 => GND_1_net, 
        WD28 => GND_1_net, WD29 => GND_1_net, WD30 => GND_1_net, 
        WD31 => GND_1_net, WD32 => GND_1_net, WD33 => GND_1_net, 
        WD34 => GND_1_net, WD35 => GND_1_net, REN => INV_0_Y, 
        RW0 => VCC_1_net, RW1 => VCC_1_net, RW2 => GND_1_net, 
        RDAD0 => RAddress(0), RDAD1 => RAddress(1), RDAD2 => 
        RAddress(2), RDAD3 => RAddress(3), RDAD4 => RAddress(4), 
        RDAD5 => RAddress(5), RDAD6 => RAddress(6), RDAD7 => 
        GND_1_net, RDAD8 => GND_1_net, RDAD9 => GND_1_net, 
        RDAD10 => GND_1_net, RDAD11 => GND_1_net, RDAD12 => 
        GND_1_net, RDAD13 => GND_1_net, RDAD14 => GND_1_net, 
        RDAD15 => GND_1_net, RD0 => Q(0), RD1 => Q(1), RD2 => 
        Q(2), RD3 => Q(3), RD4 => Q(4), RD5 => Q(5), RD6 => Q(6), 
        RD7 => Q(7), RD8 => OPEN , RD9 => OPEN , RD10 => OPEN , 
        RD11 => OPEN , RD12 => OPEN , RD13 => OPEN , RD14 => 
        OPEN , RD15 => OPEN , RD16 => OPEN , RD17 => OPEN , 
        RD18 => OPEN , RD19 => OPEN , RD20 => OPEN , RD21 => 
        OPEN , RD22 => OPEN , RD23 => OPEN , RD24 => OPEN , 
        RD25 => OPEN , RD26 => OPEN , RD27 => OPEN , RD28 => 
        OPEN , RD29 => OPEN , RD30 => OPEN , RD31 => OPEN , 
        RD32 => OPEN , RD33 => OPEN , RD34 => OPEN , RD35 => 
        OPEN );
end DEF_ARCH;
