//The Vector Generation in Verilog
// Test Bench Platform Generated by WaveFormer Lite Version 8.9
`timescale 1ns / 1ps
module stimulus(SRAM_DATA,WR_addr,RD_addr,WR_EN,RD_EN,Aclr,WClock,RClock);

inout [7:0] SRAM_DATA;
reg [7:0] SRAM_DATA_driver;
assign SRAM_DATA = SRAM_DATA_driver;
output [6:0] WR_addr;
reg [6:0] WR_addr;
input [6:0] RD_addr;
output  WR_EN;
reg  WR_EN;
output  RD_EN;
reg  RD_EN;
output  Aclr;
reg  Aclr;
output  WClock;
output  RClock;


wire [1:0] tb_status;
reg [1:0] tb_status_driver;
assign tb_status = tb_status_driver;

parameter tb_stop_time = 1059;


real RClock_JFall;
real RClock_JRise;
real RClock_MaxHL;
real RClock_MaxLH;
real RClock_MinHL;
real RClock_MinLH;
real RClock_Duty;
real RClock_Period;
real RClock_Offset;
real WClock_JFall;
real WClock_JRise;
real WClock_MaxHL;
real WClock_MaxLH;
real WClock_MinHL;
real WClock_MinLH;
real WClock_Duty;
real WClock_Period;
real WClock_Offset;

task AssignExpressions;
  begin
  RClock_JFall = 0.0;
  RClock_JRise = 0.0;
  RClock_MaxHL = 0.0;
  RClock_MaxLH = 0.0;
  RClock_MinHL = 0.0;
  RClock_MinLH = 0.0;
  RClock_Duty = 50.0;
  RClock_Period = 40.0;
  RClock_Offset = 0.0;
  WClock_JFall = 0.0;
  WClock_JRise = 0.0;
  WClock_MaxHL = 0.0;
  WClock_MaxLH = 0.0;
  WClock_MinHL = 0.0;
  WClock_MinLH = 0.0;
  WClock_Duty = 50.0;
  WClock_Period = 20.0;
  WClock_Offset = 0.0;
  end
endtask  // AssignExpressions

initial
  begin
  AssignExpressions;
  tb_status_driver <= 1'b1;
  #(tb_stop_time)
  tb_status_driver <= 1'b0;
  end

initial
  begin                  //SIGNAL SRAM_DATA
        SRAM_DATA_driver = 8'h01;
      #81
        SRAM_DATA_driver = 8'h02;
      #34
        SRAM_DATA_driver = 8'h03;
      #39
        SRAM_DATA_driver = 8'h04;
      #27
        SRAM_DATA_driver = 8'h05;
      #31
        SRAM_DATA_driver = 8'h06;
      #27
        SRAM_DATA_driver = 8'h07;
      #31
        SRAM_DATA_driver = 8'h08;
      #25
        SRAM_DATA_driver = 8'h09;
      #31
        SRAM_DATA_driver = 8'h0A;
      #30
        SRAM_DATA_driver = 8'h0B;
      #34
        SRAM_DATA_driver = 8'h0C;
      #46
        SRAM_DATA_driver = 8'hzz;
      #611
        ;
  end

initial
  begin                  //SIGNAL SRAM_DATA
        SRAM_DATA_driver = 8'bzzzzzzzz;
  end

initial
  begin                  //SIGNAL WR_addr
        WR_addr = 7'b0000000;
      #81
        WR_addr = 7'b0000001;
      #34
        WR_addr = 7'b0000010;
      #40
        WR_addr = 7'b0000011;
      #26
        WR_addr = 7'b0000100;
      #32
        WR_addr = 7'b0000101;
      #27
        WR_addr = 7'b0000110;
      #30
        WR_addr = 7'b0000111;
      #25
        WR_addr = 7'b0001000;
      #32
        WR_addr = 7'b0001001;
      #29
        WR_addr = 7'b0010000;
      #36
        WR_addr = 7'b0010001;
      #660
        ;
  end

initial
  begin                  //SIGNAL WR_EN
        WR_EN = 1'b1;
      #38
        WR_EN = 1'b0;
      #402
        WR_EN = 1'b1;
      #619
        ;
  end

initial
  begin                  //SIGNAL RD_EN
        RD_EN = 1'b1;
      #479
        RD_EN = 1'b0;
      #572
        ;
  end

initial
  begin                  //SIGNAL Aclr
        Aclr = 1'b0;
      #23
        Aclr = 1'b1;
      #1032
        ;
  end


wire [63:0] WClock_Offset_bits = $realtobits(WClock_Offset);
wire [63:0] WClock_Period_bits = $realtobits(WClock_Period);
wire [63:0] WClock_Duty_bits = $realtobits(WClock_Duty);
wire [63:0] WClock_MinLH_bits = $realtobits(WClock_MinLH);
wire [63:0] WClock_MaxLH_bits = $realtobits(WClock_MaxLH);
wire [63:0] WClock_MinHL_bits = $realtobits(WClock_MinHL);
wire [63:0] WClock_MaxHL_bits = $realtobits(WClock_MaxHL);
wire [63:0] WClock_JRise_bits = $realtobits(WClock_JRise);
wire [63:0] WClock_JFall_bits = $realtobits(WClock_JFall);

tb_clock_minmax #(1) tb_WClock(tb_status[1:0],
                                WClock,
                                WClock_Offset_bits,
                                WClock_Period_bits,
                                WClock_Duty_bits,
                                WClock_MinLH_bits,
                                WClock_MaxLH_bits,
                                WClock_MinHL_bits,
                                WClock_MaxHL_bits,
                                WClock_JRise_bits,
                                WClock_JFall_bits);


wire [63:0] RClock_Offset_bits = $realtobits(RClock_Offset);
wire [63:0] RClock_Period_bits = $realtobits(RClock_Period);
wire [63:0] RClock_Duty_bits = $realtobits(RClock_Duty);
wire [63:0] RClock_MinLH_bits = $realtobits(RClock_MinLH);
wire [63:0] RClock_MaxLH_bits = $realtobits(RClock_MaxLH);
wire [63:0] RClock_MinHL_bits = $realtobits(RClock_MinHL);
wire [63:0] RClock_MaxHL_bits = $realtobits(RClock_MaxHL);
wire [63:0] RClock_JRise_bits = $realtobits(RClock_JRise);
wire [63:0] RClock_JFall_bits = $realtobits(RClock_JFall);

tb_clock_minmax #(1) tb_RClock(tb_status[1:0],
                                RClock,
                                RClock_Offset_bits,
                                RClock_Period_bits,
                                RClock_Duty_bits,
                                RClock_MinLH_bits,
                                RClock_MaxLH_bits,
                                RClock_MinHL_bits,
                                RClock_MaxHL_bits,
                                RClock_JRise_bits,
                                RClock_JFall_bits);

  initial
    #tb_stop_time $finish;

endmodule

module tb_clock_minmax(tb_status, CLK, offset_bits, period_bits, duty_bits, minLH_bits, maxLH_bits, minHL_bits, maxHL_bits, jRise_bits, jFall_bits);
  parameter initialize = 0;

  input [1:0] tb_status;
  output CLK;
  input [63:0] offset_bits;
  input [63:0] period_bits;
  input [63:0] duty_bits;
  input [63:0] minLH_bits;
  input [63:0] maxLH_bits;
  input [63:0] minHL_bits;
  input [63:0] maxHL_bits;
  input [63:0] jRise_bits;
  input [63:0] jFall_bits;

  reg  CLK;
  real offset;
  real period;
  real duty;
  real minLH;
  real maxLH;
  real minHL;
  real maxHL;
  real jRise;
  real jFall;
  real CLK_high;
  real CLK_low;
 
  task DriveLHInvalidRegion;
    begin
    if ( (jRise + maxLH - minLH) > 0.0 )
      begin
      CLK <= 1'bx;
      #((jRise + maxLH - minLH));
      end
    end
  endtask

  task DriveHLInvalidRegion;
    begin
    if ( (jFall + maxHL - minHL) > 0.0 )
      begin
      CLK <= 1'bx;
      #((jFall + maxHL - minHL));
      end
    end
  endtask

  always
    begin
    @(posedge tb_status[0])
    offset = $bitstoreal( offset_bits );
    period = $bitstoreal( period_bits );
    duty  = $bitstoreal( duty_bits );
    minLH = $bitstoreal( minLH_bits );
    maxLH = $bitstoreal( maxLH_bits );
    minHL = $bitstoreal( minHL_bits );
    maxHL = $bitstoreal( maxHL_bits );
    jRise = $bitstoreal( jRise_bits );
    jFall = $bitstoreal( jFall_bits );
    if (period <= 0.0)
      $display("Error: Period for clock %m is invalid (period=%f).  Clock will not be driven", period);
    else if (duty <= 0.0)
      $display("Error: Duty for clock %m is invalid (duty=%f).  Clock will not be driven", duty);
    else
      begin
      CLK_low = period * duty / 100;
      CLK_high = period - CLK_low;
      
      if ( (offset + (minLH - jRise/2)) >= 0.0 )
        begin
        if (initialize)
          CLK <= 1'b0; // drive initial state
        #(offset + (minLH - jRise/2))
        ;
        end
      else
        begin // wait for x
        if (initialize)
          CLK <= 1'bx; // in middle of X region, init to X
        #((jRise/2 + maxLH) + (offset))
        CLK <= 1'b1;
        #((CLK_high - (maxLH + jRise/2) + (minHL - jFall/2)))
        DriveHLInvalidRegion;
        CLK <= 1'b0;
        #((CLK_low - (maxHL + jFall/2) + (minLH - jRise/2)))
        ;
        end
      while ( tb_status[0] == 1'b1 )
        begin : clock_loop
        DriveLHInvalidRegion;
        CLK <= 1'b1;
        #((CLK_high - (maxLH + jRise/2) + (minHL - jFall/2)))
        DriveHLInvalidRegion;
        CLK <= 1'b0;
        #((CLK_low - (maxHL + jFall/2) + (minLH - jRise/2)))
        ;
        end
      end
    end
endmodule


//Test bench module
module testbench;


parameter strobe = 2;
parameter half_cycle = 10;
integer index_i,index_o;
integer vi_F, vo_F, vb_F;

wire [7:0] SRAM_DATA;
wire [6:0] WR_addr;
wire [6:0] RD_addr;
wire  WR_EN;
wire  RD_EN;
wire  Aclr;
wire  WClock;
wire  RClock;

wire [11:0] iv ;
wire [6:0]  ov ;
wire [7:0]  bi ;

assign iv = {WClock , RClock , WR_EN , RD_EN , Aclr , WR_addr};
assign ov = RD_addr;
assign bi = SRAM_DATA;


initial begin
vi_F = $fopen("bvec.in");
vo_F = $fopen("bvec.out");
vb_F = $fopen("bvec.bi");
end

always @ (posedge WClock or negedge WClock) 
begin
 $fdisplay(vi_F, "%b",iv);
end

always @ (posedge WClock or negedge WClock) 
begin
  #(half_cycle - strobe) ;
  $fdisplay(vo_F, "%b",ov);
  #(strobe);
end

always @ (posedge WClock or negedge WClock) begin
 
 if (WR_EN == 1) 
   begin
 		   if (RD_EN == 0)
 		     begin
 		   	#(half_cycle - strobe);
 		   	$fdisplay(vb_F, "%b%s",bi,"    out");
 		   	#(strobe);
 		     end
 		   else
 			$fdisplay(vb_F, "%b%s",bi,"    in");
   end		   
 else
 	$fdisplay(vb_F, "%b%s",bi,"    in");
		
 
end


//Instantiation of the stimulus module.
stimulus stimulus_0(SRAM_DATA,WR_addr,RD_addr,WR_EN,RD_EN,Aclr,WClock,RClock);

//Instantiation of the product module.
top top_0(
	.SRAM_DATA(SRAM_DATA),
	.WR_addr(WR_addr),
	.RD_addr(RD_addr),
	.WR_EN(WR_EN),
	.RD_EN(RD_EN),
	.Aclr(Aclr),
	.WClock(WClock),
	.RClock(RClock)
	);

endmodule
